#!/usr/bin/env groovy

// this configuration is provided for the global jenkins 
// @Library('jenkins-shared-library')

// this configuration is for local jenkins
library identifier: 'jenkins-shared-library@master', retriever: modernSCM(
    [
        $class: 'GitSCMSource',
        remote: 'https://gitlab.com/g.oussamaww/jenkins-shared-labrary.git',
        credentialsId: 'gitlab-credentials'
    ]
)

def gv

pipeline {
    agent any
    tools {
        maven 'maven-3'
    }
    /*environment {
        IMAGE_NAME = "oussamaw/my-simple-webapp:java-maven-4.0"
    }*/
    stages {
        //------this stage is for init the grouvy script and assign it to gv variable------
        /*stage("init") {
            steps {
                script {
                    gv = load "script.groovy"
                }
            }
        }
        */
        stage("Increment app image version") {
            steps{
                script {
                    echo "increment the app image version"
                    sh 'mvn build-helper:parse-version versions:set \
                            -DnewVersion=\\\${parsedVersion.majorVersion}.\\\${parsedVersion.minorVersion}.\\\${parsedVersion.nextIncrementalVersion} \
                            versions:commit'
                        def matcher = readFile('pom.xml') =~ '<version>(.+)</version>'
                        def version = matcher[0][1]
                        env.IMAGE_NAME = "$version-$BUILD_NUMBER"

                }
            }
        }

        stage("build app") {
            steps {
                script {
                    echo 'building application jar...'
                    buildJar()
                }
            }
        }
        stage("build  image") {
            steps {
                script {
                    echo 'building the docker image...'
                   buildImage(env.IMAGE_NAME)
                }
            }
        }
        
        stage("push  image") {
            steps {
                script {
                   echo 'pushing the docker image ...'
                   dockerLogin()
                   dockerPush(env.IMAGE_NAME)
                }
            }
        }

        //---deploying  the application using commands
        /*
        stage("deploy") {
            steps {
                //this script is for deploying a single container                
                /*script {
                    echo 'deploying docker image to EC2'
                    def dockerCmd = "docker run -p 3001:80 -d ${IMAGE_NAME}"
                    sshagent(['ec2-server-key']) {
                        sh "ssh -o StrictHostKeyChecking=no ec2-user@54.146.203.250 ${dockerCmd}"
                    }                 
                }
                //-- a3andak tnssa matssd had comment hnaa  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

                //---this script is for deploying multiple container using docker-com
                script {
                    echo 'deploying and run multiple container in EC2'
                    def dockerComposeCmd = "docker-compose -f docker-compose.yaml up --detach"
                    sshagent(['ec2-server-key']) {
                        sh "scp -o StrictHostKeyChecking=no -v docker-compose.yaml  ec2-user@54.91.76.98:/home/ec2-user"
                        sh "ssh -o StrictHostKeyChecking=no ec2-user@54.91.76.98 ${dockerComposeCmd}"
                    }
                }
            }
        }*/
        

        //-------- deploying the application using shell script 
        
        stage("deploy") {
            steps {
                script {
                    echo 'deploying and run multiple container in EC2 using shell script'
                    def shellCmd = "bash ./server-cmds.sh ${IMAGE_NAME}"
                    def ec2Instance = "ec2-user@18.207.115.237"
                    sshagent(['ec2-server-key']) {
                        sh "scp -o StrictHostKeyChecking=no -v server-cmds.sh ${ec2Instance}:/home/ec2-user"
                        sh "scp -o StrictHostKeyChecking=no -v docker-compose.yaml ${ec2Instance}:/home/ec2-user"
                        sh "ssh -o StrictHostKeyChecking=no -v ${ec2Instance} ${shellCmd}"
                    }
                }
            }
        }

        /*stage('commit version update') {
            steps {
                script {
                    withCredentials([usernamePassword(credentialsId: 'gitlab-credentials', passwordVariable: 'PASS', usernameVariable: 'USER')]) {
                        // git config here for the first time run
                        sh 'git config --global user.email "jenkins@example.com"'
                        sh 'git config --global user.name "jenkins"'

                        sh "git remote add origin2 https://${USER}:${PASS}@gitlab.com/g.oussamaww/java-maven-app.git"
                        sh 'git add .'
                        sh 'git commit -m "ci: version bump"'
                        sh 'git push origin2 HEAD:jenkins-shared-library'
                    }
                }
            }
        }*/

    }   
}
